Subject: Re: bug#41097: 28.0.50; (dired-toggle-marks) not working after copy

From: Jean Louis <[email-masked]>
Date: Sun, 10 May 2020 22:54:09 +0300

* Drew Adams <[email-masked]> [2020-05-10 22:23]:
> > > Please reconsider.
> > 
> > Done.
> > 
> > > Can you point to any other occurrence of referring
> > > to some mark other than `D' as a "flag" - anywhere
> > > in the Dired doc or code?  All marks, including
> > > `D', are marks.  Only `D' is called "flag".
> > 
> > "Flag" is just a word.
> 
> So is "mark".  What is your point?  Only `D' has
> been called a flag by Emacs, until now.
> 
> Dired actions affect marks differently, depending
> on the mark.  There are 3 kinds of actions - 3
> groups of marks:
> 
> 1. Actions that affect only mark `*'.
> 2. Actions that affect only mark `D'.
> 3. Actions that affect all marks (including
>    `*' and `D').
> 
> By "affect" I mean either act on a file line that
> has such a mark or add such a mark to a file line.
> 
> How to refer to these actions, these groups
> of marks?  Up until your change:
> 
> 1. Emacs has always referred to #1 as "mark",
>    not making specific mention that only `*'
>    is affected.  This is the most common kind of
>    action and the most common kind of mark used.
> 
> 2. Emacs has always, everywhere, referred ONLY
>    to #2 as "flag", including the specific action
>    of UNflagging as "unflag".  That said, see #3.
> 
> 3. Emacs has always, for actions that affect ALL
>    marks or ANY mark (including `D' and `*'),
>    referred to #3 as "mark".
> 
> Could Emacs have spoken differently?
> Yes, here's a possibility (not taken by Emacs):
> 
> 1. Refer ONLY to #1 (`*') as "mark".
> 
> 2. Refer to #2 as "flag `D'", "flag for deletion".
> 
> 3. Refer to #3 as "marks and flags" and "mark
>    or flag", and point out specifically that `C',
>    `D', etc. are "flags", whereas `*' is the only
>    "mark".
> 
> Either of those approaches, the one Emacs has
> used or the other, is doable, reasonable.
> 
> But what you've done is instead inconsistent.
> In a single doc string you've changed the
> terminology, to refer to `C' as a "flag".  No
> such change for other non-`*' marks.
> 
> That means that doc for #3 is not only wrong
> but self-contradictory, as it still talks about
> the existence of multiple kinds of "mark" -
> different characters.
> 
> You say you've reconsidered.  I'd ask that you
> reconsider again.  And please elaborate on your
> "'Flag' is just a word" response to my question:
> 
>   Can you point to any other occurrence of
>   referring to some mark other than `D' as a
>   "flag" - anywhere in the Dired doc or code?  
> 
> That's not a rhetorical question.  I know of
> no such occurrence.  Do you?  I think what I've
> said above is correct, regarding #1, #2, #3.
> 
> Words matter.  I gave a reason why I think
> Emacs chose to use "flag" for `D' - and only
> for `D': to flag something is to draw special
> attention to it.

Your are rights that word matters. Then if I may ask, why is then
"flag" introduced instead of "Delete mark"?

How "flag" makes the deleting action more clear? It does not, if you
ask me.

Definition of a mark is very clear.

Wordnet:

2. (4) marker, marking, mark -- (a distinguishing symbol; "the owner's
mark was on all the sheep")

flag on the other hand is not so clear. It does not provide definition
for your intended action to draw special attention to it.

In fact, marking something is drawing special attention to it
already.

So "flag" is for me less clear. Why should "flag" be used for
"delete", why not "Delete" or "Mark delete"?

Now note that the option "flag" is under the menu "Mark", so flag is a
mark, it is adding to confusion.

In my opinion, the Menu "Mark" should not have "flag", but rather
"Delete" or "Delete mark":

- Delete auto-save files
- Delete backup files
- Delete garbage files
- Delete by extension

or

- Mark to delete auto-save files
- Mark to delete backup files
- Mark to delete garbage files
- Mark to delete by extension

Those are clear to me in that sense.

Now these are not clear to me:

- Flag extension -- how that can be clear what it does? Sure that I
  will find after some time what is meant, but I am saying, it is
  confusing and not user friendly.

The Wordnet does not indicate that "flag" has the definition that you
want, in the manner to distinguish it from "mark". It says "provide
with a flag" and flag would be what?

I will just put those definitions here down that could apply for some
user. 

>From WordNet (r) 3.0 (2006) [wn]:

  flag
      n 1: emblem usually consisting of a rectangular piece of cloth
           of distinctive design

4: a rectangular piece of fabric used as a signalling device
         [syn: {flag}, {signal flag}]
      2: provide with a flag; "Flag this file so that I can recognize
         it immediately"

      5: become less intense [syn: {ease up}, {ease off}, {slacken
         off}, {flag}]

So to flag in the meaning to provide with a flag, the Wordnet
definition gives me only that, thus definitions are missing. I
understand your point, I am just saying is not so easy to understand with
"flag".

With "mark" it is very easy to understand it:

mark

1 definition found

>From WordNet (r) 3.0 (2006) [wn]:

  mark
      2: a distinguishing symbol; "the owner's mark was on all the
         sheep" [syn: {marker}, {marking}, {mark}]

    v 1: attach a tag or label to; "label these bottles" [syn:
           {tag}, {label}, {mark}]

      5: make or leave a mark on; "the scouts marked the trail"; "ash
         marked the believers' foreheads"

Now the definition you wanted to squeeze out of the "flag" to draw
special attention to it, is actually under "mark" -- I speak only for
Wordnet.

to flag vs. to mark, those are synonyms.

It is only in Emacs terminology that "flag" became something extra,
however, it does not help the user to understand by reading from the
menu that "flag" means "to mark for deletion".

Jean